c         parameters for Elemag process.
c	(->   ----------------------------------------------

	real*8  RecoilKineMinE  !2  Recoil Kinetic Min Energy above which the recoil (=knock-on process)
                                ! is treated. Below this energy, the effect is included as continuous
                                ! energy loss.
	real*8  X0            !2  radiation length in kg/m2 for air
	real*8  Ecrit         !2  critical energy in GeV
	logical Knockon       !2  if T, Knockon process is considered
	real*8  AnihiE        !2  if E(positron)  < Eanihi, annihilation is  considered. 
	real*8  Es            !2 Modified scattering constant. 20.e-3 GeV
	real*8  MaxComptonE   !2 Above this energy, Compton is neglected. 
	real*8  MaxPhotoE     !2 Above this energy, photoelectric effect is neglected.
	real*8  MinPhotoProdE !1  Below this energy, no photo-prod of hadron.  See also PhotoProd.
	logical PhotoProd     !1  Switch. if .false., no photo prod. of hadron is considered at all. 
                              !   See also MinPhotoProdE.
        integer Moliere       !2  0--> use all Gaussian approx (with air density change and
                              !        energy loss effect)
                              !   1--> use Moliere scattering for non-electrons (default)
                              !   2--> use Moliere scattering for all charged particles.
	                      !   If negative, angle correlated displacement is made to be 0
                              !   since Moliere theory cannot give it. (if >0, we use Gaussian
                              !   approximation for correlation).
c	<-)	----------------------------------------------

	common /Zelemagc/  RecoilKineMinE, AnihiE, MaxComptonE,
     *  MaxPhotoE, MinPhotoProdE,   Es, X0, Ecrit, Knockon, 
     *  PhotoProd, Moliere

